#include <windows.h>

#ifdef __cplusplus
extern "C" {
#endif

struct sigaction
{
  void(*sa_handler)(int);
  sigset_t sa_mask;
  int sa_flags;
};

unsigned alarm(unsigned seconds);
int sigfillset(sigset_t *set);
int sigemptyset(sigset_t *set);
int sigaction(int sig, const struct sigaction *act, struct sigaction *oact);

#define SIGALRM 23

#define alloca malloc

#ifndef EWOULDBLOCK
#define EWOULDBLOCK WSAEWOULDBLOCK
#endif

#ifndef EOPNOTSUPP
#define EOPNOTSUPP WSAEOPNOTSUPP
#endif

#ifndef SHUT_RD
#   define SHUT_RD SD_RECEIVE
#endif

#ifndef SHUT_WR
#   define SHUT_WR SD_SEND
#endif

#ifndef SHUT_RDWR
#   define SHUT_RDWR SD_BOTH
#endif

#ifdef __cplusplus
}
#endif
